;TVD (Tiny Visual Designer) - Version 0.95.00
;falsam  - Cration 28/03/2011 - Derniere modification : 08/04/2011
;Pure Basic 4.51 et 4.60
;

EnableExplicit

UseSQLiteDatabase()

Enumeration 40 Step 1
  #Database; Base de donne  ouvrir
  #File ;Fichier de sauvegarde de la conception
  #MainForm ;Fenetre en cours de cration
  #TBar ; Barre d'icone
  #SBar ;Status Barre
  
  #PopUpMenu ;Menu PopUp associ
  #GadgetCopy; Menu Popup : Copier un gadget 
  #GadgetCut ;Menu Popup : Supprimer un gadget
  #GadgetPaste ;Menu Popup : Coller un gadget
  #CodeCreate ;Menu Popup : Generation du code pure basic
    
  ;Inspecteur de gadget
  #InspectorForm
  
  ;Menu
  #MainMenu
  #MnuFileNew
  #MnuFileOpen
  #MnuFileSave
  #MnuFileSaveAs
  #MnuQuit
  
  #LGadgets ;Liste des gadgets
  #Panel 
  
  ;Onglet Standard
  #IdGadget ;Handle gadget en cours de cration (Lecture seul)
  #Enum 
  #Left
  #Top
  #Width
  #Height
  #LP0 ; Aide 1 er parametre (Exemple Texte)
  #P0 ; Paramertre 1
  
  ;Onglet Options
  #Options 
  
  ;Onglet Extra
  #LHelp; Libell static
  #Help ; Aide affect au gadget
  #IncEvent ;Inclure event
  #Code ;Code affect au gadget
  
  ;Onglet Items
  #LItems ;List des items
  #ItemText ;Libell d'un item
  #ItemWidth ;Largeur d'un item
  #ItemUpdate ;Update d'un item (Ajout ou mise  jour d'une colonne)
  #ItemDel ;Suppression d'un item
  
  #SB ;StatusBar
  
  ;Gnrateur de code
  #CodeForm
 	#CodePerform ;Bouton gnrer le code
	#CodeCancel ;Bouton annuler la gnration du code
	#CodeIncEnum ;Case  cocher inclure l'numration
	#CodeIncEvent ; Case  cocher Inclure la boucle evenementielle

EndEnumeration

;Points d'ancrage d'un gadget selectionn
Enumeration 90 Step 1
  #AnchorN ;Nord
  #AnchorE ;Est
  #AnchorS ;Sud
  #AnchorW ; Ouest
  #AnchorSize ;Taille de chaque point d'ancrage
EndEnumeration

;Touche de raccourcis 
Enumeration  100 Step 1
  ;Menu PopUp
  #Kbd_MenuPopUp
  
  ;Deplacement (Ctrl + une touche de direction)
  #Kbd_CtrlUp ; Dplacement du gadget vers le haut
  #Kbd_CtrlDown ; Dplacement du gadget vers le bas
  #Kbd_CtrlRight ; Dplacement du gadget vers la droite
  #Kbd_CtrlLeft ;Dplacement du gadget vers la gauche
  
  ;Redimentionnemet du gadget (Alt + une touche de directtion)
  #Kbd_AltUp ; Hauteur en tirant par le haut 
  #Kbd_AltDown ;Hauteur en tirant par le bas 
  #Kbd_AltRight ; Largeur en tirant par la droite 
  #Kbd_AltLeft ; Largeur en tirant par la gauche
EndEnumeration

Define.l Event, EventWindow, EventGadget, EventType, EventMenu, RMouseState

;Un gadget est il survol ?
Macro GadgetHoverCheck(x, y, Gadget)
  (((Not x<GadgetX(Gadget)) & (Not y<GadgetY(Gadget))) &(Not x>=(GadgetX(Gadget)+GadgetWidth(Gadget))) & (Not y>=(GadgetY(Gadget)+GadgetHeight(gadget))))
EndMacro

;Structure modele de fenetre
Structure MWindowProperty
  Model.s           ;OpenWindow par defaut
  Enum.s            ;Enumeration
  Width.i           ;Largeur par defaut
  Height.i          ;Hauteur par defaut
  LP0.s             ;Libell pour l'inspecteur de gadget (Text, 
  Options.s         ;Options possibles (Exemple : "#PB_Text_Center,#PB_Text_Right,#PB_Text_Border"
EndStructure
Global Dim MWindow.MWindowProperty(0)

;Structure d'un modele de gadget
;Chaque gadget est dcrit dans la Data Section en fin de programme
Structure MGadgetProperty
  Model.s           ;Famille de gadget (Buttongadget, TextGadget ........)
  Enum.s            ;Enumeration
  PbAny.b           ;#Pb_Any par defaut Oui ou Non 
  AddItem.i         ;Ajout d'un item possible Oui ou Non
  Help.b            ;Aide Oui ou Non
  Width.i           ;Largeur par defaut
  Height.i          ;Hauteur par defaut
  LP0.s             ;Libell pour l'inspecteur de gadget (Text, 
  Options.s         ;Options possibles (Exemple : "#PB_Text_Center,#PB_Text_Right,#PB_Text_Border"
  CountGadget.i     ;Compteur de gadget par type de gadget
EndStructure
Global Dim  MGadget.MGadgetProperty(11)

;Structure d'un gadget et Tableau des gadgets (L'indice 0 sera rserv  la fenetre)
;Le tableau de structure s'incrmente  chaque cration de gadget.
;Un gadget dtruit sera check Actif Oui ou Non
Structure StructureGadget
  Idgadget.i        ;Identifiant gadget lors de la cration
  IdLGadgets.i      ;Position dans la combo liste gadget
  IdModel.i         ;Identifiant model de gadget
  Actif.i           ;gadget actif #True ou #False
  ColCount.i        ;Nombre de colonnes si il s'agit d'un ListIcongadget par exemple
  Enum.s            ;Enumeration
  P0.s              ;Texte ou contenu d'un gadget
  Options.s         ;Options possibles (Exemple : "#PB_Text_Center,#PB_Text_Right,#PB_Text_Border"
  Help.s            ;Aide 
  EG0.s             ;Enum Gadget pour gadget associ au gadget principal
  EG1.s             ;Enum Gadget pour gadget associ au gadget principal
  IncEvent.b        ;Inclure dans la boucle des evenements (Eventgadget)
EndStructure
Global Dim Gadgets.StructureGadget(1), IdPos.i,  IdGadget.i, CountGadgets.i

;Structure d'une copie de gadget (Copier/Coller un gadget dans le menu PopUp
Structure StructureMemGadget
  IdModel.i          ;Identifiant model de gadget
  Enum.s             ;Enumeration
  Left.i             ;Coordonne X du gadget
  Top.i              ;Coordonne Y du gadget
  Width.i            ;Largeur du gadget
  Height.i           ;Hauteur du gadget
  P0.s               ;Texte ou contenu d'un gadget 
  ColCount.i         ;Nombre de colonnes si il s'agit d'un ListIcongadget par exemple
  IText.s            ;Liblls des colonnes ou onglets d'un gadget
  IWidth.s           ;Largeurs des colonnes ou onglets d'un gadget
  EG0.s              ;Enum Gadget pour gadget associ au gadget principal
  EG1.s              ;Enum Gadget pour gadget associ au gadget principal
  Options.s          ;Options possibles (Exemple : "#PB_Text_Center,#PB_Text_Right,#PB_Text_Border"
  Help.s             ;Aide 
  IncEvent.b         ;Inclure dans la boucle des evenements (Eventgadget)
EndStructure
Global CopyGadget.StructureMemGadget

;Coordonnes X,Y de cration d'un gadget
Global X.i, Y.i, X1.i, Y1.i, Width.i, Height.i, Width1.i, Height1.i, DeltaX.i, DeltaY.i

;;Les Poignes : Couleur, Taille, Caches (Oui/Non), actif (Aucune=0,  N=1, E=2, S=3, W=4)
Global AnchorColor.i=$0000ff, AnchorSize.i=7, AnchorHide=#True, AnchorActif.i

;
Global GadgetCheck.b, GadgetDraw.b, ColCount.i, i.i, j.i

;Database (Les fichiers sont au format SQLite)
Global Database.s   ;Fichier en cours d'utilisation
Global ReqSql.s     ;Requete SQL (Lecture et enregistrement fichier)
Global DatabaseSave.b ; Faire une sauvegarde Oui ou Non
Global FileRequester.b ; Une ouverture ou un enregistrement de fichier est en cours


;Gestionnaire d'erreur
Procedure Message(MsGValue.i, Option.i=#PB_MessageRequester_Ok)
  Protected Message.s, Value.i
  Select MsgValue
    Case 00 : Message="Erreur  l'ouverture de l'application"  
    Case 10 : Message="Erreur  la cration du fichier"
  ; Case 12 : Message="Erreur  l'ouverture du fichier "+DatabaseError() 
    Case 13 : Message="Erreur  la lecture du fichier ("+DatabaseError()+")"
    Case 14 : Message="Erreur  l'enregistrement du fichier ("+DatabaseError()+")"
    Case 19 : Message="Vous n'avez pas sauvegarder votre travail !"+#CRLF$+"Etes vous sur de vouloir abandonner ?"
    Case 20 : Message="Sauvegarde effectue"
  EndSelect
  Value=MessageRequester("Information",Message, Option)
  ProcedureReturn Value
EndProcedure

;Evenement Souris (0: Rien, 1 :Clique Gauche, 2 : Clique Droit, 3 : Clique Milieu
Procedure EventMouse()
     CompilerIf #PB_Compiler_OS = #PB_OS_Linux
      Protected gdkWnd.l, x.l, y.l, mask.l, Wnd, *Window.GTKWindow
      Wnd=WindowID(GetActiveWindow())
      *Window.GTKWindow = Wnd
      gdkWnd = *Window\bin\child\window
      gdk_window_get_pointer_(gdkWnd, @x, @y, @mask)
      
      If (mask & #GDK_BUTTON1_MASK)
        ProcedureReturn 1
          
      ElseIf (mask & #GDK_BUTTON3_MASK)
       ProcedureReturn 3
        
      ElseIf (mask & #GDK_BUTTON2_MASK)
        ProcedureReturn 2
          
      EndIf  
    CompilerEndIf
      
    CompilerIf #PB_Compiler_OS = #PB_OS_Windows
      ProcedureReturn Abs(GetAsyncKeyState_(#VK_LBUTTON) + GetAsyncKeyState_(#VK_RBUTTON)*3 + GetAsyncKeyState_(#VK_MBUTTON)*2)/$8000   
    CompilerEndIf      
   
    CompilerIf #PB_Compiler_OS = #PB_OS_MacOS
       ;
       ;
    CompilerEndIf    
EndProcedure

;Initialisation des raccourcis claviers
Procedure InitShortCut(Window.i)
  ;Menu Popup(En attendant de trouver une solution pour le clic droit sous Linux)
  AddKeyboardShortcut(#MainForm, #PB_Shortcut_Insert, #Kbd_MenuPopUp)
  
  ;Positionnement des gadgets (Ctrl + Up, Down, Right ou Left)
  AddKeyboardShortcut(Window, #PB_Shortcut_Up|#PB_Shortcut_Control, #Kbd_CtrlUp)
  AddKeyboardShortcut(Window, #PB_Shortcut_Down|#PB_Shortcut_Control, #Kbd_CtrlDown)
  AddKeyboardShortcut(Window, #PB_Shortcut_Right|#PB_Shortcut_Control, #Kbd_CtrlRight)
  AddKeyboardShortcut(Window, #PB_Shortcut_Left|#PB_Shortcut_Control, #Kbd_CtrlLeft)
  
  ;Redimensionnement des gadgets (Alt + Up, Down, Right ou Left)
  AddKeyboardShortcut(Window, #PB_Shortcut_Up|#PB_Shortcut_Alt, #Kbd_AltUp)
  AddKeyboardShortcut(Window, #PB_Shortcut_Down|#PB_Shortcut_Alt, #Kbd_AltDown)
  AddKeyboardShortcut(Window, #PB_Shortcut_Right|#PB_Shortcut_Alt, #Kbd_AltRight)
  AddKeyboardShortcut(Window, #PB_Shortcut_Left|#PB_Shortcut_Alt, #Kbd_AltLeft)  
EndProcedure

;Initialisation du modele de fenetre. Lecture depuis la Data Section
Procedure InitModelWindow()
  Protected Buffer.s, i.i
  Restore ModelWindow 
    For i=1 To 6
      Read.s Buffer
      Select i
        Case 1 : MWindow(0)\Model=Buffer
        Case 2 : MWindow(0)\Width =Val(Buffer)
        Case 3 : MWindow(0)\Height=Val(Buffer)
        Case 4 : MWindow(0)\LP0=Buffer
        Case 5 : MWindow(0)\Enum=Buffer
        Case 6 : MWindow(0)\Options=Buffer
      EndSelect
    Next
EndProcedure

;Initialisation des modeles de gadgets.Lecture depuis la Data Section
;Le menu popup s'enrichit des modeles de gadgets
Procedure InitModelgadget()
  Protected Buffer.s, i.i, j.i
  Restore ModelGadgets 
  For i=1 To 10
    For j=1 To 9
      Read.s Buffer
      Select j
        Case 1 : MGadget(i)\Model=Buffer
        Case 2 : MGadget(i)\Width=Val(Buffer)
        Case 3 : MGadget(i)\Height=Val(Buffer)
        Case 4 : MGadget(i)\LP0=Buffer
        Case 5 : MGadget(i)\Enum=Buffer
        Case 6 : MGadget(i)\PbAny=Val(Buffer)
        Case 7 : MGadget(i)\AddItem=Val(Buffer)
        Case 8 : MGadget(i)\Help=Val(Buffer)
        Case 9 : MGadget(i)\Options=Buffer
      EndSelect
    Next  
    
    ;Mise  jour du menu popup
    MenuItem((i), MGadget(i)\Model)
  Next  
  
  ;Ajout des items de Copier/Couper/Coller un gadget
  MenuBar()
  MenuItem(#GadgetCopy,"Copier") 
  MenuItem(#GadgetCut,"Couper") 
  MenuItem(#GadgetPaste,"Coller") 
  
  ;Ajout de l'item gnration du code
  MenuBar()
  MenuItem(#CodeCreate,"Gnration du code")
EndProcedure

;Desactiver l'inspecteur de gadget
Procedure InspectorDisable(Value.i)
  DisableGadget(#Enum, Value)
  DisableGadget(#Left, Value)
  DisableGadget(#Top, Value)
  DisableGadget(#Width, Value)
  DisableGadget(#Height, Value)
  HideGadget(#P0, Value)
EndProcedure

;Mise  jour de l'inspecteur de gadget (Si Idgadget=0, il s'agit de la fenetre)
Procedure InspectorUpdate(IdGadget.i)
  Protected i.i, j.i,  Buffer.s
  If IdGadget=0 ;Lecture des information de la fenetre en cours de cration
    SetGadgetText(#Enum, Gadgets(0)\Enum)
    SetGadgetText(#Left, Str(WindowX(#MainForm)))
    SetGadgetText(#Top, Str(WindowY(#Mainform)))
    SetGadgetText(#Width, Str(WindowWidth(#MainForm)))
    SetGadgetText(#Height, Str(WindowHeight(#Mainform)))
    DisableGadget(#P0,#False)
    SetGadgetText(#LP0, MWindow(0)\LP0)
    SetGadgetText(#P0, Gadgets(0)\P0)
    
    HideGadget(#LHelp, #True)
    HideGadget(#Help, #True)
    HideGadget(#IncEvent, #True)
    HideGadget(#SB, #False)
    
    ;Quels sont les options possibles pour la fenetre ?
    Buffer=MWindow(0)\Options
    ClearGadgetItems(#Options)
    For i=1 To CountString(Buffer,",")+1
      If Trim(StringField(Buffer,i,","))<>""
        AddGadgetItem(#Options, -1, StringField(Buffer,i,","))
      EndIf
    Next
    
    ;Quels sont les options utilises pour la fentre ?
    Buffer=Gadgets(0)\Options
    For i=1 To CountString(Buffer,"|")+1
      For j=0 To CountGadgetItems(#Options)-1
        If GetGadgetItemText(#Options,j)=StringField(Buffer,i,"|")
          SetGadgetItemState(#Options, j, #PB_ListIcon_Checked)
        EndIf
      Next
    Next  
    
    ClearGadgetItems(#LItems)
    DisableGadget(#ItemText, #True)
    DisableGadget(#ItemWidth, #True)
    DisableGadget(#ItemUpdate, #True)
    DisableGadget(#ItemDel, #True)
    
  Else ;Lecture des informations du gadget en cours de cration ou de modification
    HideGadget(#LHelp, #False)
    HideGadget(#Help, #False)
    HideGadget(#IncEvent, #False)
    HideGadget(#SB, #True)
    
    For i=1 To CountGadgetItems(#LGadgets)
      If GetGadgetItemData(#LGadgets, i)=IdGadget
        SetGadgetState(#LGadgets,i)
      EndIf
    Next
    
    SetGadgetText(#Left, Str(GadgetX(IdGadget)))
    SetGadgetText(#Top, Str(GadgetY(IdGadget)))
    SetGadgetText(#Width, Str(GadgetWidth(IdGadget)))
    SetGadgetText(#Height, Str(GadgetHeight(IdGadget)))
  EndIf
  
  ;Si le gadget est en cours de dplacement 
  ;Il est inutiles de raffraichir les informations 
  If GadgetDraw=#False And IdGadget<>0
    SetGadgetText(#IdGadget, Str(IdGadget))
    SetGadgetText(#Enum, Gadgets(GetGadgetData(IdGadget))\Enum)
    
    ;Un libell est il  renseigner pour ce gadget ? (On teste P0)
    If MGadget(Gadgets(GetGadgetData(IdGadget))\IdModel)\LP0<>""
      DisableGadget(#P0,#False)
      DisableGadget(#LP0,#False)
      SetGadgetText(#LP0, MGadget(Gadgets(GetGadgetData(IdGadget))\IdModel)\LP0)
      SetGadgetText(#P0, Gadgets(GetGadgetData(IdGadget))\P0)  
    Else
      DisableGadget(#P0, #True)
      DisableGadget(#LP0, #True)
      SetGadgetText(#P0, "")
    EndIf
    
    ;Quels sont les options possibles pour le  gadget slectionn ?
    Buffer=MGadget(Gadgets(GetGadgetData(IdGadget))\IdModel)\Options
    ClearGadgetItems(#Options)
    For i=1 To CountString(Buffer,",")+1
      If Trim(StringField(Buffer,i,","))<>""
        AddGadgetItem(#Options, -1, StringField(Buffer,i,","))
      EndIf
    Next
    
    ;Quels sont les options utilises pour le gadget selectionn ?
    Buffer=Gadgets(GetGadgetData(IdGadget))\Options
    For i=1 To CountString(Buffer,"|")+1
      For j=0 To CountGadgetItems(#Options)-1
        If GetGadgetItemText(#Options,j)=StringField(Buffer,i,"|")
          SetGadgetItemState(#Options, j, #PB_ListIcon_Checked)
        EndIf
      Next
    Next
    
    ;Un ListIconGadget est il survoll
    If Gadgets(GetGadgetData(IdGadget))\IdModel=6
      ClearGadgetItems(#LItems)
      ColCount=Gadgets(GetGadgetData(IdGadget))\ColCount
      For i=0 To (ColCount)
        AddGadgetItem(#Litems, -1, GetGadgetItemText(Idgadget, -1, i)+Chr(10)+Str(GetGadgetItemAttribute(IdGadget, 0, #PB_ListIcon_ColumnWidth,i )))
      Next
      
      ;DisableGadget(#ItemUpdate, #False)
      ;DisableGadget(#ItemDel, #False)
      DisableGadget(#ItemText, #False)
      DisableGadget(#ItemWidth,#False)      
    Else
      ClearGadgetItems(#LItems)
      DisableGadget(#ItemUpdate, #True)
      DisableGadget(#ItemDel, #True)
      DisableGadget(#ItemText, #True)
      DisableGadget(#ItemWidth,#True)    
    EndIf
    
    ;Une aide est t'il possible pour ce modele de gadget
    If MGadget(Gadgets(GetGadgetData(IdGadget))\IdModel)\Help=1
      DisableGadget(#Help,#False)
      SetGadgetText(#Help, Gadgets(GetGadgetData(IdGadget))\Help)
    Else
      DisableGadget(#Help, #True)
      SetGadgetText(#Help, "") 
    EndIf
    
    ;Le gadget est il inclus dans la boucle evenementielle
    If Gadgets(GetGadgetData(IdGadget))\IncEvent=1
      SetGadgetState(#IncEvent, #PB_Checkbox_Checked)
    Else
      SetGadgetState(#IncEvent, #PB_Checkbox_Unchecked)
    EndIf
    
  EndIf
EndProcedure

;RAZ de l'inspecteur de gadget
Procedure InspectorClear()
  SetGadgetText(#IdGadget, "") 
  SetGadgetText(#Enum, "") 
  SetGadgetText(#Left, "") 
  SetGadgetText(#Top, "") 
  SetGadgetText(#Width, "")
  SetGadgetText(#Height,"")
  SetGadgetText(#Help,"")
  SetGadgetText(#ItemText,"")
  SetGadgetText(#ItemWidth,"")
  
  ClearGadgetItems(#LGadgets)
  ClearGadgetItems(#Options)
  ClearGadgetItems(#LItems)
  
  InspectorDisable(#True)
EndProcedure

;Cration des points d'ancrage
Procedure AnchorCreate()
  TextGadget(#AnchorN, 0, 0, AnchorSize, AnchorSize,"") 
  TextGadget(#AnchorE, 0, 0, AnchorSize, AnchorSize,"")
  TextGadget(#AnchorS, 0, 0, AnchorSize, AnchorSize,"")
  TextGadget(#AnchorW, 0, 0, AnchorSize, AnchorSize,"")
    
  SetGadgetColor(#AnchorN, #PB_Gadget_BackColor, AnchorColor)
  SetGadgetColor(#AnchorE, #PB_Gadget_BackColor, AnchorColor)
  SetGadgetColor(#AnchorS, #PB_Gadget_BackColor, AnchorColor)
  SetGadgetColor(#AnchorW, #PB_Gadget_BackColor, AnchorColor)
EndProcedure

;Cache les points d'ancrage
Procedure AnchorHide(Value.b)
  HideGadget(#AnchorN, Value)
  HideGadget(#AnchorE, Value)
  HideGadget(#AnchorS, Value) 
  HideGadget(#AnchorW, Value)
  AnchorHide=Value
EndProcedure

;Positionne les point d'ancrage
Procedure AnchorMove(IdGadget)
  Protected Left.i, Top.i, Width.i, Height.i
  Left=GadgetX(IdGadget)
  Top=GadgetY(IdGadget)
  Width=GadgetWidth(IdGadget)
  Height=GadgetHeight(IdGadget)
  If AnchorHide=#True
    AnchorHide(#False)
  EndIf
    
  ResizeGadget(#AnchorN, (Left+Width/2), Top-AnchorSize, AnchorSize, AnchorSize)
  ResizeGadget(#AnchorS, Left+Width/2, Top+Height+AnchorSize/4, AnchorSize,AnchorSize)
  ResizeGadget(#AnchorE, Left+AnchorSize/2+Width, Top+(Height-AnchorSize)/2, AnchorSize, AnchorSize)
  ResizeGadget(#AnchorW, Left-AnchorSize, Top+(Height-AnchorSize)/2, AnchorSize, AnchorSize)
EndProcedure

;Quel est le point d'ancrage actif
Procedure GetAnchorCheck()
  If GadgetDraw=#False
    AnchorActif=#False

    If GadgetHoverCheck(x,y,#AnchorN)
     AnchorActif=1
    EndIf
  
    If GadgetHoverCheck(x,y,#AnchorS)
      AnchorActif=2
    EndIf  
  
    If GadgetHoverCheck(x,y,#AnchorE)
      AnchorActif=3
    EndIf
  
    If GadgetHoverCheck(x,y,#AnchorW)
      AnchorActif=4
    EndIf 
  
    ProcedureReturn AnchorActif
  EndIf
EndProcedure

;Modification de la taille des points d'ancrages
Procedure AnchorResize()
  AnchorSize=Val(GetGadgetText(#AnchorSize))
  If IdGadget<>0
    AnchorMove(IdGadget)  
  EndIf          
EndProcedure

;Ajout d'une barre de status
Procedure WindowAddSBar()
  If GetGadgetState(#SB)=#True
    CreateStatusBar(#SBar, WindowID(#Mainform))
    Gadgets(0)\EG0="#SB_"+Gadgets(0)\Enum
  Else
    Gadgets(0)\EG0=""
    FreeStatusBar(#SBar)
  EndIf
  DatabaseSave=#False
EndProcedure

;Mise  jour de la liste des gadget (Combo #LGadgets)
Procedure LGadgetsUpdate()
  Protected i.i
  ClearGadgetItems(#LGadgets)
  For i=0 To CountGadgets
    If Gadgets(i)\Actif=#True
      Gadgets(i)\IdLGadgets=i
      AddGadgetItem(#LGadgets, -1, Gadgets(i)\Enum+" ("+MGadget(Gadgets(i)\IdModel)\Model+")")
      SetGadgetItemData(#LGadgets, CountGadgetItems(#LGadgets)-1, Gadgets(i)\Idgadget)
    EndIf
  Next 
EndProcedure

;Repositionne le gadget 
Procedure GadgetDraw(KbdValue.i, Idgadget.i)
  
  ;Un gadget est il toujours selectionn ?
  If IdGadget<>0
    Width=GadgetWidth(Idgadget) 
    Height=GadgetHeight(IdGadget)
    
    If AnchorActif>0
      DeltaX=0 : DeltaY=0
      Select AnchorActif
        Case 1 ;Nord
          X=GadgetX(IdGadget)
          Height=Height+(GadgetY(IdGadget)-Y)
          
        Case 2 ;Sud
          X=GadgetX(IdGadget)
          Height=Y-GadgetY(IdGadget)
          Y=GadgetY(IdGadget)
          
        Case 3 ;Est
          Y=GadgetY(IdGadget)
          Width=X-GadgetX(IdGadget)
          X=GadgetX(IdGadget)
          
        Case 4 ;Ouest
          Y=GadgetY(IdGadget)
          Width=Width+(GadgetX(IdGadget)-X)

      EndSelect  
    EndIf

    ;S'agit il d'un redimentionnement avec les touches du clavier
    If KbdValue<>0
      DeltaX=0 : DeltaY=0
      X=GadgetX(IdGadget)
      Y=GadgetY(IdGadget)
      Select KbdValue
          ;Dplacement d'un gadget  avec la combinaison de touches Ctrl + Fleches
          Case #Kbd_CtrlUp : Y=GadgetY(IdGadget)-1
          Case #Kbd_CtrlDown : Y=GadgetY(IdGadget)+1
          Case #Kbd_CtrlRight :  X=GadgetX(IdGadget)+1
          Case #Kbd_CtrlLeft : X=GadgetX(IdGadget)-1
          
          ;Redimensionnement d'un gadget avec la combinaison de touches Alt + Fleches
         Case #Kbd_AltUp :  Height=GadgetHeight(IdGadget)-1
         Case #Kbd_AltDown : Height=GadgetHeight(IdGadget)+1
         Case #Kbd_AltLeft : Width=GadgetWidth(Idgadget)-1
         Case #Kbd_AltRight : Width=GadgetWidth(Idgadget)+1    
       EndSelect  
       ResizeGadget(Idgadget, X, Y, Width, Height)
       AnchorMove(Idgadget)
       InspectorUpdate(Idgadget)  
    Else
       ;Quelques chose est il modifi dans les dimensions ?
       If (X1<>X) Or (Y1<>Y) Or (Width1<>Width) Or (Height1<>Height) ;And AnchorActif=0
         ResizeGadget(Idgadget, X-DeltaX, Y-DeltaY, Width, Height) 
         AnchorMove(Idgadget)
       EndIf    
       X1=X : Y1=Y : Width1=Width : Height1=Height  
    EndIf
  EndIf
  DatabaseSave=#False
EndProcedure

;Redimentionne le gadget (A intgrer  la procedure GadgetDraw)
Procedure GadgetResize(IdGadget.i)
  If IdGadget=0  
    ;Changement de la postion et redimensionnement de la fenetre 
    If EventType()=#PB_EventType_LostFocus
      ResizeWindow(#MainForm, Val(GetGadgetText(#Left)), Val(GetGadgetText(#Top)), Val(GetGadgetText(#Width)), Val(GetGadgetText(#Height)))   
    EndIf
  Else
    ;Changement de la position et redimentionnement d'un gadget
    ResizeGadget(IdGadget, Val(GetGadgetText(#Left)), Val(GetGadgetText(#Top)), Val(GetGadgetText(#Width)), Val(GetGadgetText(#Height)))
    AnchorMove(IdGadget)  
  EndIf
  DatabaseSave=#False
EndProcedure

;Selectionner un gadget  modifier depuis la comboliste des gadgets (#LGadgets)
Procedure GadgetSelect()
  IdGadget=GetGadgetItemData(#LGadgets, GetGadgetState(#LGadgets))
  If Idgadget<>0 ;Different de la fenetre en cours de creation
    AnchorMove(IdGadget)  
  Else
    AnchorHide(#True)  
  EndIf
  GadgetCheck=#True
  InspectorUpdate(Idgadget)
  InspectorDisable(#False)
EndProcedure

;Cration d'un gadget en fonction de l'item selectionn depuis le menu contextuel (PopUp)
;IdModel : Modele de gadget  crer
;Copy
; 0 : Cration avec les valeurs par defaut
; 1 : Cration depuis un gadget copi
; 2 : Cration suite  l'ouverture d'un fichier
Procedure GadgetCreate(IdModel.i, Copy.i)
  Protected Width.i, Height.i, P0.s, Buffer.s
   
  ;Mise  jour du compteur de gadget associ au model de gadget
  MGadget(IdModel)\CountGadget=MGadget(IdModel)\CountGadget+1
  
  ;Incrmentation du compteurs de gadget Global
  CountGadgets=CountGadgets+1
  
  ;Redimentionnement du tableau de gadgets
  ReDim Gadgets(CountGadgets)
  
  ;Rcupration des valeurs par defaut depuis le tableau des models de gadget
  Width=MGadget(IdModel)\Width
  Height=MGadget(IdModel)\Height
  P0=MGadget(IdModel)\Enum+Str(MGadget(IdModel)\CountGadget)
  
  ;S'agit il d'une copie d'un gadget?
  If Copy=1 Or Copy=2
    Width=CopyGadget\Width
    Height=CopyGadget\Height
    P0=CopyGadget\P0
  EndIf
  
  If Copy=2
    X=CopyGadget\Left
    Y=CopyGadget\Top
  EndIf
  
  ;Quel est le gadget  crer
  Select IdModel
    Case 1 : IdGadget=ButtonGadget(#PB_Any, X, Y, Width, Height, P0)   
    Case 2 : IdGadget=CheckBoxGadget(#PB_Any, X, Y, Width, Height, P0)
    Case 3
      IdGadget=ComboBoxGadget(#PB_Any, X, Y, Width, Height, #PB_ComboBox_Editable) 
      AddGadgetItem(Idgadget,-1,"")
      
    Case 4 : IdGadget=EditorGadget(#PB_Any, X, Y, Width, Height, #PB_Editor_ReadOnly)
    Case 5 : IdGadget=Frame3DGadget(#PB_Any, X, Y, Width, Height, P0)
    Case 6 : IdGadget=ListIconGadget(#PB_Any, X, Y, Width, Height, P0,100)    
    Case 7 : IdGadget=ListViewGadget(#PB_Any, X, Y, Width, Height)
    Case 8 : IdGadget=OptionGadget(#PB_Any, X, Y, Width, Height, P0)
    Case 9 : IdGadget=StringGadget(#PB_Any, X, Y, Width, Height, P0)
    Case 10 : IdGadget=TextGadget(#PB_Any, X, Y, Width, Height, P0)
  EndSelect
  
  ;On affecte le compteur de gadget global  ce nouveau gadget
  SetGadgetData(IdGadget, CountGadgets)
  
  ;Enregistrement du gadget dans le tableau des gadgets
  ;Il est inutile d'enregitrer les proprites X,Y, Width et Height du gadget 
  ;On utilisera les fonctions GadgetX,  GadgetY, GadgetWidth et GadgetHeight
  ;A la cration du gadget , Enum sera egale  P0
  Gadgets(CountGadgets)\Actif=#True
  Gadgets(CountGadgets)\IdGadget=Idgadget
  Gadgets(CountGadgets)\IdModel=IdModel  
  Gadgets(CountGadgets)\P0=P0
  
  ;Enumration 
  If MGadget(IdModel)\PbAny=#True
    Gadgets(CountGadgets)\Enum="#Pb_Any"
  Else
    Gadgets(CountGadgets)\Enum="#"+MGadget(IdModel)\Enum+Str(MGadget(IdModel)\CountGadget)
  EndIf
  
  If Copy=2
    Gadgets(CountGadgets)\Enum=CopyGadget\Enum
  EndIf
 
  If Copy=1 Or Copy=2 
    If CopyGadget\ColCount>0
      RemoveGadgetColumn(IdGadget,0)
      For i=1 To (CopyGadget\ColCount)+1
        AddGadgetColumn(IdGadget, i, StringField(CopyGadget\IText, i, "|"), Val(StringField(CopyGadget\IWidth, i, "|")))
      Next
    EndIf
    
    Gadgets(CountGadgets)\ColCount=CopyGadget\ColCount
    Gadgets(CountGadgets)\Help=CopyGadget\Help
    Gadgets(CountGadgets)\Options=CopyGadget\Options
    Gadgets(CountGadgets)\IncEvent=CopyGadget\IncEvent
  EndIf
   
  ;Mise  jour du combo liste des gadget (#LGadgets)
  ;Chaque item reoit le handle du gadget (IdGadget)
  AddGadgetItem(#LGadgets, -1, Gadgets(CountGadgets)\Enum+" ("+MGadget(Gadgets(CountGadgets)\IdModel)\Model+")")
  SetGadgetState(#LGadgets, CountGadgetItems(#LGadgets)-1)
  SetGadgetItemData(#LGadgets, CountGadgetItems(#LGadgets)-1, IdGadget)
  
  If Copy=0
    ;Mise en place des points d'ancrages
    AnchorMove(IdGadget)
  
    ;Mise  jour de l'inspecteur de gadget
    InspectorUpdate(IdGadget)
  
    ;Indicateur d'une sauvegarde  effectuer
    DatabaseSave=#False
  EndIf
EndProcedure

;Modifie le nom du gadget ou de la fenetre
Procedure GadgetUpdateEnum(IdGadget.i)
  ;Le caractre # doit exister
  If Mid(GetGadgetText(#Enum),1,1)<>"#"
    SetGadgetText(#Enum,"#"+GetGadgetText(#Enum))
  EndIf
                     
  If IdGadget=0  
    ;Changement de l'num de la fenetre
    Gadgets(0)\Enum=GetGadgetText(#Enum)
    
    ;Existe t'il une barre de status
    If Gadgets(0)\EG0<>""
      Gadgets(0)\EG0="SB_"+Gadgets(0)\Enum
    EndIf
    
    LGadgetsUpdate()
    SetGadgetState(#LGadgets, 0)
  Else
    ;Changement de l'num du gadget
    Gadgets(GetGadgetData(IdGadget))\Enum=GetGadgetText(#Enum)
    LGadgetsUpdate()
    SetGadgetState(#LGadgets, Gadgets(GetGadgetData(IdGadget))\IdLGadgets)
  EndIf
EndProcedure

;Un gadget peut posseder plusieurs parametres (Texte, Minimum, maximum, etc .....)
Procedure GadgetUpdatePX(IdGadget)
  If IdGadget=0
    ;Changement du titre de la fenetre
    SetWindowTitle(#Mainform, GetGadgetText(#P0))
    Gadgets(0)\P0=GetGadgetText(#P0)
  Else
    ;Changement du texte du gadget concern
    SetGadgetText(IdGadget, GetGadgetText(#P0))
    Gadgets(GetGadgetData(IdGadget))\P0=GetGadgetText(#P0)  
  EndIf
EndProcedure

;Associe un texte flottant au gadget spcifi (GadgetToolTip)
Procedure GadgetSetHelp(IdGadget.i)
  If IdGadget=0 
    ;Rien pour le moment
  Else
    Gadgets(GetGadgetData(IdGadget))\Help=GetGadgetText(#Help)
  EndIf
EndProcedure

;Inclus le gadget dans la boucle evenementielle (EventGadget)
Procedure GadgetIncEvent()
  If IdGadget=0 
    ;Rien pour le moment
  Else
    Gadgets(GetGadgetData(IdGadget))\IncEvent=GetGadgetState(#IncEvent)
  EndIf

EndProcedure

;Ajoute une option  un gadget ou .......  la fenetre.
Procedure GadgetSetOptions(IdGadget.i)
  If IdGadget=0
    ;Fenetre en cours de cration
     IdPos=0   
  Else
    ;Gadget en cours de cration : Rcupration de la position 
    IdPos=GetGadgetData(IdGadget)
  EndIf
  
  Gadgets(IdPos)\Options=""
  j=0
    For i=0 To CountGadgetItems(#Options)-1
      If GetGadgetItemState(#Options,i)=#PB_ListIcon_Checked
        If j>0
          Gadgets(IdPos)\Options=Gadgets(IdPos)\Options+"|"  
        EndIf
        j=j+1
        Gadgets(IdPos)\Options=Gadgets(IdPos)\Options+GetGadgetItemText(#Options,i)  
      EndIf  
  Next
EndProcedure

;Ajoute ou modifie un lment  un gadget (Colonne, Onglet, ...)
Procedure GadgetSetElements(IdGadget)
  If Trim(GetGadgetText(#ItemText))<>""
    If GetGadgetData(#ItemUpdate)=0
      ;Ajout d'un element 
      AddGadgetColumn(IdGadget, CountGadgetItems(#LItems), GetGadgetText(#ItemText), Val(GetGadgetText(#ItemWidth)))
      ColCount=ColCount+1 : Gadgets(GetGadgetData(IdGadget))\ColCount=Colcount
      InspectorUpdate(IdGadget)
    
    Else
    
      ;Modification d'un lement (Titre / Largeur)
      SetGadgetItemText(Idgadget, -1, GetGadgetText(#ItemText), GetGadgetState(#LItems))
      SetGadgetItemAttribute(Idgadget, 0, #PB_ListIcon_ColumnWidth, Val(GetGadgetText(#ItemWidth)), GetGadgetState(#LItems))
      InspectorUpdate(Idgadget)
      SetGadgetData(#ItemUpdate, 0)  
      SetGadgetText(#ItemUpdate,"+")
      DisableGadget(#ItemUpdate, #True)
      DisableGadget(#ItemDel, #True)                

    EndIf
    SetGadgetText(#ItemText, "")
    SetGadgetText(#ItemWidth, "100")
 EndIf
EndProcedure

;Enleve un element  un gadget (Colonne, Onglet, ...)
Procedure GadgetDelElement(IdGadget.i)
  If CountGadgetItems(#LItems)>1
    RemoveGadgetColumn(IdGadget, GetGadgetState(#LItems))
    ColCount=ColCount-1 : Gadgets(GetGadgetData(IdGadget))\ColCount=Colcount
    RemoveGadgetItem(#LItems, GetGadgetState(#LItems))
    InspectorUpdate(Idgadget)
  Else
    MessageRequester("Info","Vous devez laisser au moins une colonne")
EndIf
EndProcedure

;Copy d'un gadget depuis l'emplacement de la souris 
Procedure GadgetCopy(IdGadget.i)
  Protected IText.s, IWidth.s, i.i, j.i
  CopyGadget\IdModel=Gadgets(GetGadgetData(IdGadget))\IdModel
  CopyGadget\Width=GadgetWidth(IdGadget)
  CopyGadget\Height=GadgetHeight(IdGadget)
  CopyGadget\P0=Gadgets(GetGadgetData(IdGadget))\P0 
  CopyGadget\ColCount=Gadgets(GetGadgetData(IdGadget))\ColCount
  
  If Gadgets(GetGadgetData(IdGadget))\IdModel=6
    For j=0 To Gadgets(GetGadgetData(IdGadget))\ColCount
      IText=IText+GetGadgetItemText(Gadgets(GetGadgetData(IdGadget))\Idgadget, -1, j)
      IWidth=IWidth+Str(GetGadgetItemAttribute(Gadgets(GetGadgetData(IdGadget))\Idgadget, 0, #PB_ListIcon_ColumnWidth,j))
      If j<>Gadgets(GetGadgetData(IdGadget))\ColCount
        IText=IText+"|"
        IWidth=IWidth+"|"  
      EndIf  
    Next  
  EndIf 
  CopyGadget\IText=IText
  CopyGadget\IWidth=IWidth
  CopyGadget\Options=Gadgets(GetGadgetData(IdGadget))\Options 
  CopyGadget\Help=Gadgets(GetGadgetData(IdGadget))\Help
EndProcedure

;Annulation d'un gadget (Recupration du numro de compteur affect au gadget)
Procedure GadgetCut(IdGadget.i)
  Protected i.i
  Gadgets(GetGadgetData(IdGadget))\Actif=#False
  AnchorHide(#True)
  HideGadget(IdGadget, #True)
  LGadgetsUpdate() ;Mise  jour de la comboliste des gadgets
  SetGadgetState(#LGadgets, 0)
  GadgetSelect()
EndProcedure

;Copie du gadget  l'emplacement de la souris
Procedure GadgetPaste()
  GadgetCreate(CopyGadget\IdModel, 1)
EndProcedure

;Gnration du code qui sera copi dans le presse papier
Procedure CodeCreate()
  Protected i.i, j.i, Code.s, Model.s, Enum.s, X.s, Y.s, Width.s, Height.s, P0.s
  
  If GetGadgetState(#CodeIncEnum)=#True
    ;Enumration
    Code=Code+"Enumeration"+#CRLF$
    For i=0 To (CountGadgets)
     If Gadgets(i)\Actif=#True
       If Gadgets(i)\Enum<>"#Pb_Any"
         Code=Code+#TAB$+Gadgets(i)\Enum+#CRLF$
       EndIf
     EndIf
    Next
    Code=Code+"EndEnumeration"+#CRLF$+#CRLF$
  
    Code=Code+"Define.l Event, EventWindow, EventGadget, EventType, EventMenu"+#CRLF$+#CRLF$
  EndIf
  
  ;Fenetre en cours de cration
  Enum=Gadgets(0)\Enum
  X=Str(WindowX(#MainForm))
  Y=Str(WindowY(#MainForm))
  Width=Str(WindowWidth(#MainForm))
  Height=Str(WindowHeight(#MainForm))
  P0=Gadgets(0)\P0
  
  Code=Code+"Procedure Open_"+Mid(Enum,2,Len(Enum)-1)+"()"+#CRLF$
  Code=Code+#TAB$+"If OpenWindow("+Enum+","+X+","+Y+","+Width+","+Height+","+Chr(34)+P0+Chr(34)
  
  ;Existe t'il des options pour la fenetre
  If Gadgets(0)\Options<>""
    Code=Code+","+Gadgets(0)\Options  
  EndIf
      
  ;Fin du codage de la fenetre
  Code=Code+")"+#CRLF$
      
  For i=1 To (CountGadgets)
    If Gadgets(i)\Actif=#True
      IdGadget=Gadgets(i)\IdGadget
      Model=MGadget(Gadgets(i)\IdModel)\Model
      Enum=Gadgets(i)\Enum
      X=Str(GadgetX(IdGadget))
      Y=Str(GadgetY(IdGadget))
      Width=Str(GadgetWidth(IdGadget))
      Height=Str(GadgetHeight(IdGadget))
      P0=Gadgets(i)\P0
    
      ;Partie commune (Enumeration, X, Y, Width, Height, Texte )
      Code=Code+#TAB$+#TAB$+Model+"("+Enum+","+X+","+Y+","+Width+","+Height
      
      ;Il y a t'il un texte ?
      If MGadget(Gadgets(GetGadgetData(IdGadget))\IdModel)\LP0<>""
        Code=Code+","+Chr(34)+P0+Chr(34)
      EndIf
      
      ;S'agit il d'un ListIconGadget
      If Gadgets(i)\IdModel=6
        Code=Code+","+Chr(34)+GetGadgetItemText(Idgadget, -1, 0)+Chr(34)+","+Str(GetGadgetItemAttribute(IdGadget, 0, #PB_ListIcon_ColumnWidth,0 ))
      EndIf
                
      ;Existe t'il des options pour le gadget
      If Gadgets(i)\Options<>""
        Code=Code+","+Gadgets(i)\Options
      EndIf
      
      ;Fin du codage du gadget
      Code=Code+")"+#CRLF$
      
      ;Gadgets Items - Ajouts des colonnes
      If Gadgets(i)\IdModel=6
        For j=1 To Gadgets(i)\ColCount
          Code=Code+#TAB$+#TAB$+"AddGadgetColumn("+Enum+","+Str(j)+", "+Chr(34)+GetGadgetItemText(Idgadget, -1, j)+Chr(34)+","
          Code=Code+Str(GetGadgetItemAttribute(IdGadget, 0, #PB_ListIcon_ColumnWidth,j))+")"+#CRLF$
        Next
      EndIf
      
      ;Existe t'il une aide pour ce gadget
      If Trim(Gadgets(i)\Help)<>""
        Code=Code+#TAB$+#TAB$+"GadgetToolTip("+Enum+","+Chr(34)+Gadgets(i)\Help+Chr(34)+")"+#CRLF$
      EndIf
      
    EndIf
  Next
  
  Code=Code+#TAB$+"EndIf"+#CRLF$
  Code=Code+"EndProcedure"+#CRLF$+#CRLF$
  
  Enum=Gadgets(0)\Enum
  Code=Code+"Open_"+Mid(Enum, 2, Len(Enum)-1)+"()"+#CRLF$+#CRLF$
  
  If GetGadgetState(#CodeIncEvent)=#True
    Code=Code+"Repeat"+#CRLF$
    ;Boucle evenementiel
    Code=Code+#TAB$+"Event = WaitWindowEvent()"+#CRLF$
  
    Code=Code+#TAB$+"Select Event"+#CRLF$
    Code=Code+#TAB$+#TAB$+"Case #PB_Event_Menu"+#CRLF$+#CRLF$
    Code=Code+#TAB$+#TAB$+"Case #PB_Event_Gadget"+#CRLF$+#CRLF$
    Code=Code+#TAB$+#TAB$+#TAB$+"Select EventGadget()"+#CRLF$+#CRLF$
    For i=1 To (CountGadgets)
      If Gadgets(i)\Actif=#True
       If Gadgets(i)\IncEvent=#True
         Code=Code+#TAB$+#TAB$+#TAB$+#TAB$+"Case "+Gadgets(i)\Enum+#CRLF$+#CRLF$
       EndIf
      EndIf
    Next
   Code=Code+#TAB$+#TAB$+#TAB$+"EndSelect"+#CRLF$+#CRLF$
   Code=Code+#TAB$+#TAB$+"Case #PB_Event_CloseWindow"+#CRLF$
   Code=Code+#TAB$+#TAB$+#TAB$+"End"+#CRLF$+#CRLF$
   Code=Code+#TAB$+"EndSelect"+#CRLF$
  
   Code=Code+"ForEver"+#CRLF$
 EndIf
   
  ;Le code est dans le presse papier
  SetClipboardText(Code)
  MessageRequester("Information", "Le code est copi dans le presse-papier")
  CloseWindow(#CodeForm)
EndProcedure

;Un gadget est il selectionn
Procedure GetGadgetCheck()
  Protected i.i
  If GadgetDraw=#False
    GadgetCheck=#False   
    For i=1 To CountGadgets     
      If GadgetHoverCheck(X, Y, Gadgets(i)\Idgadget) And Gadgets(i)\Actif=#True
        IdGadget=Gadgets(i)\Idgadget
 
        ;Delta entre la position de la souris et les bords haut/gauche du gadget     
        DeltaX=X-GadgetX(IdGadget)
        DeltaY=Y-GadgetY(Idgadget)
        GadgetCheck=#True
        InspectorUpdate(Idgadget)
      EndIf  
    Next
  EndIf
  ProcedureReturn GadgetCheck
EndProcedure

;Fenetre en cours de cration
Procedure MainFormShow()
  OpenWindow(#MainForm,370,100,500,400,"Nouvelle Fenetre",#PB_Window_SizeGadget | #PB_Window_SystemMenu, WindowID(#InspectorForm))
  CreatePopupMenu(#PopUpMenu)
EndProcedure

;Affichage du menu contextuel (PopUp), Mise  jour du ou des items valide
Procedure MenuPopUpShow()
  ;Mmorisation des coordonnes de la souris avant la creation du gadget 
  X=WindowMouseX(#MainForm)
  Y=WindowMouseY(#Mainform)
  
  ;Un gadget est il survol : Si Oui possibilit de le supprimer
  If GetGadgetCheck()
    DisableMenuItem(#PopUpMenu, #GadgetCopy, #False)
    DisableMenuItem(#PopUpMenu, #GadgetCut, #False)
  Else
    DisableMenuItem(#PopUpMenu, #GadgetCopy, #True)
    DisableMenuItem(#PopUpMenu, #GadgetCut, #True)
  EndIf
  
  ;Un gadget est il copier en mmoire
  If CopyGadget\IdModel<>0
    DisableMenuItem(#PopUpMenu, #GadgetPaste, #False)
  Else
    DisableMenuItem(#PopUpMenu, #GadgetPaste, #True)
  EndIf
     
  ;Affichage du menu contextuel
  DisplayPopupMenu(#PopUpMenu,WindowID(#MainForm)) 
EndProcedure

;Inspecteur de gadget
Procedure InspectorFormShow()
  OpenWindow(#InspectorForm, 100, 100, 250, 400, "Tiny Visual Designer",#PB_Window_SystemMenu)
  
  ;Menu 
  CreateMenu(#MainMenu, WindowID(#InspectorForm))
  MenuTitle("Fichier")
  MenuItem(#MnuFileNew, "Nouveau")
  MenuItem(#MnuFileOpen, "Ouvrir")
  MenuItem(#MnuFileSave, "Sauvegarder")
  MenuItem(#MnuFileSaveAs, "Sauvegarder sous ...")
  MenuItem(#MnuQuit, "Quitter")
    
  ComboBoxGadget(#LGadgets, 5 ,15, 240, 22) ;Liste des gadgets
    
  PanelGadget(#Panel, 5, 50, 240, 300)
  
  ;Valeurs standard d'un gadget
  AddGadgetItem (#Panel, -1, "Standard")
  TextGadget(#PB_Any, 5, 10,60,20,"Handle")
  TextGadget(#Idgadget, 80, 10, 100, 20,"")
  TextGadget(#PB_Any, 5, 35, 60, 20, "Enumeration")
  StringGadget(#Enum, 80, 35, 100, 20, "")
  TextGadget(#PB_Any, 5, 60, 60, 20, "Left")
  StringGadget(#Left, 80, 60, 100, 20, "")
  TextGadget(#PB_Any, 5, 85, 60, 20, "Top")
  StringGadget(#Top, 80, 85, 100, 20, "")
  TextGadget(#PB_Any, 5, 110, 60, 20, "Width")
  StringGadget(#Width, 80, 110, 100, 20, "")
  TextGadget(#PB_Any, 5, 135, 60, 20, "Height")
  StringGadget(#Height, 80, 135, 100, 20, "")
  TextGadget(#LP0, 5, 160, 60, 20, "")
  StringGadget(#P0, 80, 160, 100, 20, "")
  
  ;Options
  AddGadgetItem (#Panel, -1, "Options")
  ListIconGadget(#Options,5, 5, 225, 260,"Flags",210, #PB_ListIcon_CheckBoxes)
  
  ;Extras (Aide, Couleurs, etc ....)
  AddGadgetItem (#Panel, -1, "Extra")
  TextGadget(#LHelp, 5, 10, 80, 20, "Tool Tip")
  StringGadget(#Help, 5, 30, 170, 20, " ")  
  CheckBoxGadget(#IncEvent, 5, 60, 260, 20, "Inclure boucle venement.")
  CheckBoxGadget(#SB, 5, 10, 260, 20, "Ajoute une barre d'tat  la fentre.") 
  HideGadget(#SB, #True)
  
  
  ;Items (Ajout, Suppression, Mise  jour)
  AddGadgetItem (#Panel, -1, "Items")
  ListIconGadget(#LItems, 5, 10, 225, 200, "Item(s)",140, #PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)
  AddGadgetColumn(#LItems, 1, "Longueur", 73)
  StringGadget(#ItemText, 5, 220, 140, 20,"")
  SpinGadget(#ItemWidth, 150, 220, 40, 20,  0, 1000, #PB_Spin_Numeric)
  SetGadgetState(#ItemWidth, 100)
  ButtonGadget(#ItemUpdate, 192, 220, 20, 20,"+")
  ButtonGadget(#ItemDel, 213, 220, 20, 20,"-")
  CloseGadgetList()
  
  TextGadget(#PB_Any, 5, 355, 75, 20, "Anchor Size")
  SpinGadget(#AnchorSize, 80, 350, 30, 20, 5, 20,#PB_Spin_ReadOnly|#PB_Spin_Numeric)
  SetGadgetState (#AnchorSize, AnchorSize)
EndProcedure

Procedure CodeShow()
	If OpenWindow(#CodeForm,0,0,280,155,"Gnration du code Pure Basic",#PB_Window_TitleBar|#PB_Window_WindowCentered)
		CheckBoxGadget(#CodeIncEnum, 50, 20, 200, 32, "Inclure l'numration")
		CheckBoxGadget(#CodeIncEvent, 50, 60, 200, 32, "Inclure la boucle evenementielle")
  	ButtonGadget(#CodePerform, 49, 120, 80, 20, "Gnrer")
  	ButtonGadget(#CodeCancel, 150, 120, 80, 20, "Annuler")
  	
  	SetGadgetState(#CodeIncEnum, #PB_Checkbox_Checked)
  	SetGadgetState(#CodeIncEvent, #PB_Checkbox_Checked)
	EndIf
EndProcedure

;Reset de l'application
Procedure Reset()
  Protected i.i
  
  ;Si le fichier est ouvert -> fermeture du fichier
  If IsDatabase(#File)
    CloseDatabase(#File)
    ;Database=""
  EndIf
    
  ;Cache les points d'ancrages
  AnchorHide(#True)
  
  ;Supprime les gadgets si ceux ci sont encore prsent
  For i=1 To CountGadgets
    HideGadget(Gadgets(i)\Idgadget, #True)
  Next
  
  ;Clear du tableau des gadgets
  ReDim Gadgets(0)
  Gadgets(0)\Options=""
  
  ;Clear 
  CopyGadget\Options=""
  
  ;Reset des compteurs par gadget
  For i=1 To 10
    MGadget(i)\CountGadget=0
  Next i
  
  ;Reset du compteur de gadgets general
  CountGadgets=0
  
  ;Redimentionnement de la fenetre (valeur par defaut)
  ResizeWindow(#Mainform, 370, 100, MWindow(0)\Width, MWindow(0)\Height)
  
  If IsStatusBar(#SBar)
    FreeStatusBar(#SBar)
    SetGadgetState(#SB, #PB_Checkbox_Unchecked)
  EndIf
  
  ;Reset de l'inspecteur de gadget 
  InspectorClear()
  
  ;On se positionne sur le 1er onglet de l'inspecteur de gadget
  SetGadgetState(#Panel, 0)
 
  ;Parametre par defaut de la fenetre 
  Gadgets(0)\Enum="#"+MWindow(0)\Enum
  Gadgets(0)\P0="New Window"
  Gadgets(0)\IdModel=0
  Gadgets(0)\Actif=#True
  Gadgets(0)\IncEvent=#False
  
  ;Mise  jour de la combo liste des gadgets avec l'enum de la nouvelle fenetre
  AddGadgetItem(#LGadgets, -1, Gadgets(0)\Enum+" ("+MGadget(Gadgets(0)\IdModel)\Model+")")
  SetGadgetState(#LGadgets, 0)
  SetGadgetItemData(#LGadgets, 0, 0)
  
  ;Mise  jour et mode dition de l'inspecteur de gadget 
  InspectorUpdate(0)
  InspectorDisable(#False)
  
  ;Inutile de demander une sauvegarde
  DatabaseSave=#True
  
EndProcedure

;Fermeture d'un fichier
Procedure FileClose()
  Protected Result.i
  ;Sauvegarde effectue ?
  If DatabaseSave=#False
    Result=Message(19, #PB_MessageRequester_YesNo)
    If Result=#PB_MessageRequester_Yes
      DatabaseSave=#True 
    EndIf
  EndIf
  ProcedureReturn DatabaseSave
EndProcedure

;Nouveau fichier
Procedure FileNew()
  FileRequester=#True
  ;Sauvegarde effectue ?
  If Fileclose()
    Reset() ;Reset de l'environnement de cration
  EndIf
  IdGadget=0
  Database=""
  FileRequester=#False
EndProcedure

;Ouverture d'un dichier de sauvegarde
Procedure FileOpen()
  FileRequester=#True
  Protected i.i
  
  ;;Sauvegarde effectue ?
  If FileClose()
    Database=OpenFileRequester("","*.tvd","T.V.D.(*.tvd)|*.tvd|Tous les fichiers (*.*)|*.*",0)
    
    If Database
      ;Reset de l'environnement de cration
      Reset() 
    
      If OpenDatabase(#File,Database,"","",#PB_Database_SQLite)
        ReqSQL="SELECT ENUM,IDMODEL,LEFT,TOP,WIDTH,HEIGHT,P0,ICOLCOUNT,ITEXT,IWIDTH,EG0,EG1,OPTIONS,HELP,INCEVENT FROM GADGETS"
        DatabaseQuery(#File,ReqSQL)
         i=0
        While NextDatabaseRow(#File)
          CopyGadget\Enum=GetDatabaseString(#File,0)
          CopyGadget\IdModel=Val(GetDatabaseString(#File,1))
          CopyGadget\Left=Val(GetDatabaseString(#File,2))
          CopyGadget\Top=Val(GetDatabaseString(#File,3))
          CopyGadget\Width=Val(GetDatabaseString(#File,4))
          CopyGadget\Height=Val(GetDatabaseString(#File,5))
          CopyGadget\P0=GetDatabaseString(#File,6)
          CopyGadget\ColCount=Val(GetDatabaseString(#File,7))
          CopyGadget\IText=GetDatabaseString(#File,8)
          CopyGadget\IWidth=GetDatabaseString(#File,9)
          CopyGadget\EG0=GetDatabaseString(#File,10) 
          CopyGadget\EG1=GetDatabaseString(#File,11) 
          CopyGadget\Options=GetDatabaseString(#File,12) 
          CopyGadget\Help=GetDatabaseString(#File,13)
          CopyGadget\IncEvent=Val(GetDatabaseString(#File,14))
          
         ;Cration de la fenetre (Le 1er enregistremetn de la base correspond  la fenetre
         If i=0
           ResizeWindow(#MainForm, CopyGadget\Left, CopyGadget\Top, CopyGadget\Width, CopyGadget\Height)
           SetWindowTitle(#MainForm, CopyGadget\P0)
           Gadgets(0)\Actif=#True
           Gadgets(0)\Enum=GetDatabaseString(#File,0)
           Gadgets(0)\P0=GetDatabaseString(#File,6)
           Gadgets(0)\IdModel=0
           Gadgets(0)\Options=CopyGadget\Options
           If CopyGadget\EG0<>""
             Gadgets(0)\EG0=CopyGadget\EG0
             SetGadgetState(#SB, #True)
             WindowAddSBar()
           EndIf
                    
           ClearGadgetItems(#LGadgets) 
           AddGadgetItem(#LGadgets, -1, Gadgets(0)\Enum+" ("+MGadget(Gadgets(0)\IdModel)\Model+")")
         EndIf
      
         ;Creation des gadgets
         If i>0
           GadgetCreate(CopyGadget\IdModel, 2)
         EndIf
         i=i+1  
       Wend   
      EndIf  
    EndIf
    
   SetGadgetState(#LGadgets, 0)
   ;SetGadgetItemData(#LGadgets, CountGadgetItems(#LGadgets)-1, 0)
   SetGadgetItemData(#LGadgets, 0, 0)
   Idgadget=0
   AnchorHide(#True)
   InspectorUpdate(0)
   
   DatabaseSave=#True
 EndIf
 FileRequester=#False
EndProcedure

;Sauvegarder la conception
Procedure FileSave()
  Protected i.i, j.i, IText.s, IWidth.s
  FileRequester=#True
  
  ;Vider le fichier SQListe
  ReqSql="Delete From Gadgets"
  DatabaseUpdate(#File, ReqSql)
  FinishDatabaseQuery(#File)
  
  ;Sauvegarder la fenetre
  ReqSql="INSERT INTO GADGETS (ENUM,IDMODEL,LEFT,TOP,WIDTH,HEIGHT,P0,EG0,EG1,OPTIONS) values ('"
  ReqSql+Gadgets(0)\Enum  + "','"
  ReqSql+Str(Gadgets(0)\IdModel)  + "','"
  ReqSql+Str(WindowX(#Mainform))  + "','"
  ReqSql+Str(WindowY(#Mainform))  + "','"
  ReqSql+Str(WindowWidth(#Mainform))  + "','"
  ReqSql+Str(WindowHeight(#Mainform))  + "','"
  ReqSql+Gadgets(0)\P0  + "','"
  ReqSql+Gadgets(0)\EG0  + "','"
  ReqSql+Gadgets(0)\EG1  + "','"
  ReqSql+Gadgets(0)\Options +"')"
  DatabaseUpdate(#File, ReqSql)
  FinishDatabaseQuery(#File)
    
  ;Sauvegarde des gadgets de la fenetre 
  For i=1 To (CountGadgets)
    If Gadgets(i)\Actif=#True
      ReqSql="INSERT INTO GADGETS (ENUM,IDMODEL,LEFT,TOP,WIDTH,HEIGHT,P0,ICOLCOUNT,ITEXT,IWIDTH,OPTIONS,HELP,INCEVENT) values ('"
      ReqSql+Gadgets(i)\Enum  + "','"
      ReqSql+Str(Gadgets(i)\IdModel)  + "','"
      ReqSql+Str(GadgetX(Gadgets(i)\Idgadget))  + "','"
      ReqSql+Str(GadgetY(Gadgets(i)\Idgadget))  + "','"
      ReqSql+Str(GadgetWidth(Gadgets(i)\Idgadget))  + "','"
      ReqSql+Str(GadgetHeight(Gadgets(i)\Idgadget))  + "','"
      ReqSql+Gadgets(i)\P0  + "','"
      ReqSql+Str(Gadgets(i)\ColCount) + "','"
      IText="" : IWidth=""
      If Gadgets(i)\IdModel=6
        For j=0 To Gadgets(i)\ColCount
          IText=IText+GetGadgetItemText(Gadgets(i)\Idgadget, -1, j)
          IWidth=IWidth+Str(GetGadgetItemAttribute(Gadgets(i)\Idgadget, 0, #PB_ListIcon_ColumnWidth,j))
          If j<>Gadgets(i)\ColCount
            IText=IText+"|"
            IWidth=IWidth+"|"
          EndIf  
        Next  
      EndIf 
      ReqSql+IText  + "','"
      ReqSql+IWidth  + "','"
      ReqSql+Gadgets(i)\Options  + "','"
      ReqSql+Gadgets(i)\Help + "','"
      ReqSql+Str(Gadgets(i)\IncEvent) +"') "
                 
      DatabaseUpdate(#File, ReqSql)
      FinishDatabaseQuery(#File)
      DatabaseSave=#True
    EndIf  
  Next
  
  FileRequester=#False
EndProcedure

;Sauvegarder la conception As .....
Procedure FileSaveAs()
  FileRequester=#True
  
  ;Choisir un emplacement de sauvegarde
  Database=SaveFileRequester("", "*.TVD", " T.V.D.(*.tvd)|*.tvd|Tous les fichiers (*.*)|*.*", 0)
  
  ;Vrification extension du fichier
  If FindString(Database,".",1)=0
    Database=Database+".tvd"
  EndIf
  
  ;Cration de la base vide
  If Database<>""
    If CreateFile(#File, Database)
      CloseFile(#File)  
    Else
      Message(10)
    EndIf
  EndIf  
  
  ;Cration de la tables des gadgets
  If OpenDatabase(#File, Database, "", "",#PB_Database_SQLite)
    ReqSql="CREATE TABLE "+Chr(39)+"GADGETS"+Chr(39)+" (IDGADGET INTEGER PRIMARY KEY, IDMODEL TEXT, ENUM TEXT, LEFT TEXT, TOP TEXT, WIDTH TEXT, HEIGHT TEXT, P0 TEXT,ICOLCOUNT TEXT, ITEXT TEXT, IWIDTH TEXT, EG0 TEXT, EG1 TEXT, OPTIONS TEXT, HELP TEXT, INCEVENT TEXT)"
    If DatabaseUpdate(#File, ReqSql)
      FinishDatabaseQuery(#File)
      FileSave()
    Else 
      Message(10)
    EndIf
  EndIf
  FileRequester=#False    
EndProcedure

Procedure EndProgram()
  If FileClose()
    End
  EndIf
EndProcedure

;Start
Procedure Start()
  ;Affichage de l'inspecteur de gadget
  InspectorFormShow()
  
  ;Affichage de la fenetre en cours de cration
  MainFormShow()
  
  ;Initialisation du model de fenetre
  InitModelWindow()
  
  ;Initialisation des modeles de gadgets 
  InitModelgadget()
  
  ;Initialisation des touches de racourrcis
  InitShortCut(#MainForm)
  InitShortCut(#InspectorForm)
  
  ;Initialisation des points d'ancrage 
  AnchorCreate()
  AnchorHide(#True)
    
  Reset()
  
EndProcedure

Start()

;-Boucle evenementielle
Repeat 
  Event=WaitWindowEvent() 
  If GetActiveWindow()=#MainForm
  Select EventMouse()
        Case 0
          If RMouseState=1 
            RMouseState=2
          Else
            RMouseState=0
            If GadgetDraw=#True
              InspectorDisable(#False)
              InspectorUpdate(Idgadget)
              GadgetDraw=#False ;Le gadget n'est plus en cours de dplacement
              AnchorActif=#False ;Les point d'ancrages ne sont plus actifs (Mais restent visibles)
              
              ;Astuce pour eviter le phenomene de superposition en attendant mieux
              ResizeGadget(IdGadget, #PB_Ignore, #PB_Ignore,GadgetWidth(Idgadget)+1,#PB_Ignore)
              ResizeGadget(IdGadget, #PB_Ignore, #PB_Ignore,GadgetWidth(Idgadget)-1,#PB_Ignore)
            EndIf
          EndIf
               
        Case 1 ;Bouton gauche de la souris 
          RMouseState=0
          ;Quels sont les coordonnes de la souris ?
          X=WindowMouseX(#MainForm)
          Y=WindowMouseY(#Mainform)
          
          ;Un gadget ou un point d'ancrage est il selectionn ?
          If GetAnchorCheck()>0 Or GetGadgetCheck() Or AnchorActif>0
            GadgetDraw=#True ; Le gadget selectionn est susceptible d'etre dplacer            
            GadGetDraw(0, IdGadget)
          EndIf  
          
        Case 2 ;Bouton central de la souris
          RMouseState=0
          
        Case 3 ;Bouton droit de la souris
          If RMouseState=0
            RMouseState=1
          EndIf
  EndSelect   
  EndIf
      
  If RMouseState=2
     MenuPopUpShow()
     RMouseState=0
  EndIf    
  
  Select Event
    Case #PB_Event_Menu
      Select EventMenu()
        Case 1 To 10 ;Cration d'un gadget
          GadgetCreate(EventMenu(), #False)
          
        Case #Kbd_MenuPopUp
          MenuPopUpShow()
          
        Case #GadgetCopy ;Copie d'un gadget
          GadgetCopy(IdGadget)
          
        Case #GadgetCut ;Enlever un gadget
          GadgetCopy(IdGadget)
          GadgetCut(Idgadget) 
         
        Case #GadgetPaste ;Inserer un gadget copier   
          GadgetPaste()
          
        Case #CodeCreate ;Gnration du code
          CodeShow()
          
        Case #MnuFileNew ;Nouveau fichier
          FileNew()
          
        Case #MnuFileOpen ;Ouverture d'un fichier
          FileOpen()
          
        Case #MnuFileSave ;Sauvegarde d'un fichier
          If Database<>""
            FileSave()
          Else
            FileSaveAs()
          EndIf
                    
        Case #MnuFileSaveAs ;Sauvegarder un fichier sous ...
          FileSaveAs()
          
        Case #MnuQuit ;Quitter l'application
          EndProgram()
          
        Default ;Resize gadget avec les touches du clavier
          GadgetDraw(EventMenu(), IdGadget)         
          
      EndSelect
                  
    Case  #PB_Event_Gadget
      If FileRequester=#False
      If IsWindow(#MainForm) ;La fenetre en cours de cration doit etre prsente
        If EventWindow()=#InspectorForm ; Les vnements viennent bien de l'inspecteur de gadget
          ;-Gadgets : Inspecteur
          DatabaseSave=#True
          Select EventGadget()  
            Case #LGadgets
              GadgetSelect()
                    
            Case #Enum
              GadgetUpdateEnum(IdGadget)

            Case #P0
              GadgetUpdatePX(Idgadget)
             
            Case #Left, #Top, #Width, #Height
              GadgetResize(IdGadget)
                     
            Case #Options ;Ajoute une option  un gadget ou  la fenetre
              GadgetSetOptions(IdGadget)
          
            Case #LItems ; ListIconGadget()
              SetGadgetText(#ItemText, GetGadgetItemText(#Litems, GetGadgetState(#LItems), 0))
              SetGadgetText(#ItemWidth, GetGadgetItemText(#Litems, GetGadgetState(#LItems), 1))
              SetGadgetData(#ItemUpdate, 1) ; On indique qu'il s'agit d'une eventuelle modification
              SetGadgetText(#ItemUpdate,"U")
                 
            Case #ItemUpdate ;Ajoute ou modifie un lment  un gadget (Colonne, Onglet, ...)
              GadgetSetElements(Idgadget)     
              
            Case #ItemText
              If Trim(GetGadgetText(#ItemText))=""
                DisableGadget(#ItemUpdate, #True)
                DisableGadget(#ItemDel, #True)
              Else
                DisableGadget(#ItemUpdate, #False)
                DisableGadget(#ItemDel, #False)                
              EndIf
          
            Case #ItemDel ;Suppression d'un lment (Colonne, Onglet, ...)
              GadgetDelElement(Idgadget)
          
            Case #Help ;Associe un texte flottant au gadget spcifi (GadgetToolTip)
              GadgetSetHelp(Idgadget)
              
            Case #IncEvent
              GadgetIncEvent()
              
            Case #SB
              WindowAddSBar()
                
            Case #AnchorSize ;Modification de la taille des points d'ancrages
              AnchorResize()
                           
         EndSelect  
       EndIf  
       
       ;Boite de dialogue Gnration du code
       If EventWindow()=#CodeForm
         Select EventGadget()
           Case #CodeCancel
              CloseWindow(#CodeForm)
             
            Case #CodePerform
              CodeCreate()
          EndSelect
       EndIf
     EndIf
     EndIf
    
    Case #PB_Event_MoveWindow, #PB_Event_SizeWindow
      If GetGadgetState(#LGadgets)=0
        SetGadgetText(#Left, Str(WindowX(#Mainform)))
        SetGadgetText(#Top, Str(WindowY(#Mainform)))
        SetGadgetText(#Width, Str(WindowWidth(#Mainform)))
        SetGadgetText(#Height, Str(WindowHeight(#Mainform)))
      EndIf
            
    Case #PB_Event_CloseWindow ;-Fermeture d'une fenetre
        EndProgram()
  EndSelect
ForEver


DataSection
  ModelWindow:
  Data.s "OpenWindow","500","400","Text","Window_0","#PB_Window_SystemMenu,#PB_Window_MinimizeGadget,#PB_Window_MaximizeGadget,#PB_Window_SizeGadget,#PB_Window_Invisible,#PB_Window_TitleBar,#PB_Window_BorderLess,#PB_Window_Tool,#PB_Window_ScreenCentered,#PB_Window_WindowCentered,#PB_Window_Maximize,#PB_Window_Minimize,#PB_Window_NoGadgets"
  
  ;Modeles gadget (10 Actuellement dans la liste)  
  ModelGadgets: 
  ;data.s "gadget", "widthDefaut", "HeightDefaut", "Caption or Blank", "Enum", "#PB_any (#False, #True)", "Gadget With Collum (#False, #True)", "Help (#False, #True)", "Flags"   
  Data.s "ButtonGadget","80","20","Text","Button_","0","0","1","#PB_Button_Right,#PB_Button_Left,#PB_Button_Default,#PB_Button_MultiLine,#PB_Button_Toggle"
  Data.s "CheckBoxGadget","80","20","Text","CheckBox_","0","0","1","#PB_CheckBox_Right,#PB_CheckBox_Center,#PB_CheckBox_ThreeState"
  Data.s "ComboBoxGadget","100","20","","Combo_","0","0","1","#PB_ComboBox_Editable,#PB_ComboBox_LowerCase,#PB_ComboBox_UpperCase,#PB_ComboBox_Image"
  Data.s "EditorGadget","150","200","","Editor_","0","0","1","#PB_Editor_ReadOnly"
  Data.s "Frame3DGadget","180","150","Texte","Frame_","1","0","1","#PB_Frame3D_Single,#PB_Frame3D_Double,#PB_Frame3D_Flat"
  Data.s "ListIconGadget","180","180","","ListIcon_","0","1","1","#PB_ListIcon_CheckBoxes,#PB_ListIcon_MultiSelect,#PB_ListIcon_GridLines,#PB_ListIcon_FullRowSelect,#PB_ListIcon_HeaderDragDrop,#PB_ListIcon_AlwaysShowSelection"
  Data.s "ListViewGadget","150","150","","ListView_","0","0","1","#PB_ListView_Multiselect,#PB_ListView_ClickSelect"
  Data.s "OptionGadget","80","20","Texte","Option_","0","0","1",""
  Data.s "StringGadget","80","20","Text","String_","0","0","1","#PB_String_Password,#PB_String_ReadOnly,#PB_String_Numeric,#PB_String_LowerCase,#PB_String_UpperCase,#PB_String_BorderLess"
  Data.s "TextGadget","80","20","Text","Text_","1","0","0","#PB_Text_Center,#PB_Text_Right,#PB_Text_Border"
EndDataSection